#import "MyOpenGLView.h"

GLfloat ambientLight[] = { 0.3, 0.3, 0.3, 1.0 };
GLfloat diffuseLight[] = { 0.7, 0.7, 0.7, 1.0 };
GLfloat lightPosition[] = { 0.2f, 0.2f, -0.0f, 0.0f };
GLfloat  spotDir[] = { 0.0f, 0.0f, -1.0f };


GLfloat no_mat[] = { 0.0, 0.0, 0.0, 1.0 };
GLfloat mat_ambient[] = { 0.7, 0.7, 0.7, 1.0 };
GLfloat mat_ambient_color[] = { 0.8, 0.8, 0.2, 1.0 };
GLfloat mat_diffuse[] = { 0.1, 0.5, 0.8, 1.0 };
GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
GLfloat no_shininess[] = { 0.0 };
GLfloat low_shininess[] = { 5.0 };
GLfloat high_shininess[] = { 100.0 };
GLfloat mat_emission[] = { 0.3, 0.2, 0.2, 0.0 };
GLfloat lmodel_ambient[] = {0.1, 0.1, 0.1, 1.0};

GLfloat white_light[] = {1.0, 1.0, 1.0, 1.0};
GLfloat red[] = { 1.0, 0.0, 0.0, 1.0 };
GLfloat blue[] = {0.0f, 0.0f, 1.0f, 1.0};

@implementation MyOpenGLView
- (id) init
{
	self = [super init];
	if (self != nil) {
		xRot = 0.0f;
		yRot = 0.0f;
		zRot = 0.0f;
	}
	return self;
}


- (void)prepareOpenGL
{
	
	NSLog(@"preparing OpenGL");
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f );
	
	glShadeModel(GL_SMOOTH);
	
	//glLightModelfv(GL_LIGHT_MODEL_AMBIENT, red);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);
	
}

-(void)reshape
{
	[[self openGLContext]makeCurrentContext];
	NSLog(@"reshaping...");
	NSRect bounds = [self bounds];
	glViewport(0, 0, NSWidth(bounds), NSHeight(bounds));
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-100, 100, -100, 100, -100, 100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	[NSOpenGLContext clearCurrentContext];
}

- (void)drawRect:(NSRect)rect
{
	NSLog(@"drawing rect...");

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, low_shininess);
	
	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, red);
	glLightfv(GL_LIGHT0, GL_SPECULAR, white_light);
	
	
	glPushMatrix();		
		glutSolidSphere(50, 50, 50);
	glPopMatrix();

	[[self openGLContext]flushBuffer];
}



-(IBAction)rotateY:(id)sender
{
	yRot = [sender floatValue];
	[self setNeedsDisplay:YES];
}

-(IBAction)rotateX:(id)sender
{
	xRot = [sender floatValue];
	[self setNeedsDisplay:YES];	
}

-(IBAction)rotateZ:(id)sender
{
	zRot = [sender floatValue];
	[self setNeedsDisplay:YES];
}


@end